import pygame, sys, time, random
from pygame.locals import *

# set up pygame
pygame.init()
mainClock = pygame.time.Clock()

# set up the window
WINDOWWIDTH = 500
WINDOWHEIGHT = 500
windowSurface = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT), 0, 32)
pygame.display.set_caption('eat!')

# set up the colors
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)

# set up the block data structure
player = pygame.Rect(300, 100, 40, 40)
playerImage = pygame.image.load('player.png')
playerStretchedImage = pygame.transform.scale(playerImage, (40, 40))
foodImage = pygame.image.load('cherry.png')
foods = []
for i in range(100):
    foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - 20), random.randint(0, WINDOWHEIGHT - 20), 20, 20))

foodCounter = 0
NEWFOOD = 10
nextSize = 5
sizeCounter = 0
score = 0

# set up fonts
basicFont = pygame.font.SysFont(None, 48)
smallFont = pygame.font.SysFont(None, 18)
hugeFont = pygame.font.SysFont(None, 80)

# set up keyboard variables
moveLeft = False
moveRight = False
moveUp = False
moveDown = False

MOVESPEED = 12

# set up music
pickUpSound = pygame.mixer.Sound('pickup.wav')
GameOverSound = pygame.mixer.Sound('gameover.wav')
pygame.mixer.music.load('background.mid')
#pygame.mixer.music.play(-1, 0.0)
#musicPlaying = True
musicPlaying = False

#Is game started ?
started = False
showMenu = False
starting = False
Finish = True
line = True
Tick = 40
needed = 5
neededTicker = 0
timer = 60
timerTicker = 0

text = basicFont.render('Eat!', True, WHITE, RED)
textRect = text.get_rect()
textEnter = smallFont.render('Press ENTER to start', True, WHITE, RED)
textEnterRect = textEnter.get_rect()
textHuge = hugeFont.render(str(needed), True, WHITE, RED)
textHugeRect = textHuge.get_rect()
textScore = smallFont.render('Score: ' + str(score), True, WHITE, RED)
textScoreRect = textScore.get_rect()
textTimer = smallFont.render('Timer: ' + str(timer), True, WHITE, RED)
textTimerRect = textTimer.get_rect()
textGameOver = hugeFont.render('!!GAME OVER!!', True, WHITE, RED)
textGameOverRect = textGameOver.get_rect()
textEndScore = basicFont.render('Score: ' + str(score), True, WHITE, RED)
textEndScoreRect = textEndScore.get_rect()

textRect.centerx = windowSurface.get_rect().centerx
textRect.centery = windowSurface.get_rect().centery
textEnterRect.centerx = windowSurface.get_rect().centerx
textEnterRect.centery = windowSurface.get_rect().centery  + 25
textHugeRect.centerx = windowSurface.get_rect().centerx
textHugeRect.centery = windowSurface.get_rect().centery
textScoreRect.left = windowSurface.get_rect().left
textScoreRect.top = windowSurface.get_rect().top
textTimerRect.left = windowSurface.get_rect().left
textTimerRect.top = textScoreRect.bottom
textGameOverRect.top = windowSurface.get_rect().top + 45
textGameOverRect.centerx = windowSurface.get_rect().centerx
textEndScoreRect.top = textGameOverRect.bottom + 10
textEndScoreRect.centerx = windowSurface.get_rect().centerx

# run the game loop
while True:
    # check for the QUIT event
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        if started == True:
            if event.type == KEYDOWN:
                # change the keyboard variables
                if event.key == K_LEFT or event.key == ord('a'):
                    moveRight = False
                    moveLeft = True
                if event.key == K_RIGHT or event.key == ord('d'):
                    moveLeft = False
                    moveRight = True
                if event.key == K_UP or event.key == ord('w'):
                    moveDown = False
                    moveUp = True
                if event.key == K_DOWN or event.key == ord('s'):
                    moveUp = False
                    moveDown = True
            if event.type == KEYUP:
                if event.key == K_ESCAPE:
                    pygame.quit()
                    sys.exit()
                if event.key == K_LEFT or event.key == ord('a'):
                    moveLeft = False
                if event.key == K_RIGHT or event.key == ord('d'):
                    moveRight = False
                if event.key == K_UP or event.key == ord('w'):
                    moveUp = False
                if event.key == K_DOWN or event.key == ord('s'):
                    moveDown = False
                if event.key == ord('x'):
                    player.top = random.randint(0, WINDOWHEIGHT - player.height)
                    player.left = random.randint(0, WINDOWWIDTH - player.width)
                if event.key == ord('m'):
                    if musicPlaying:
                        pygame.mixer.music.stop()
                    else:
                        pygame.mixer.music.play(-1, 0.0)
                    musicPlaying = not musicPlaying
                if event.key == K_l or event.key == ord('l'):
                    line = not line
            if event.type == MOUSEBUTTONUP:
                foods.append(pygame.Rect(event.pos[0] - 10, event.pos[1] - 10, 20, 20))
        else:
            if event.type == KEYUP:
                if event.key == K_RETURN:
                    starting = True
                    showMenu = False
                    score = 0
                    timer = 1
                    sizeCounter = 0
                    needed = 5
                    neededTicker = 0
                    player = pygame.Rect(player.left, player.top, 40, 40)
                    playerStretchedImage = pygame.transform.scale(playerImage, (40, 40))
                    windowSurface.fill(BLACK)
                if event.key == ord('m'):
                    if musicPlaying:
                        pygame.mixer.music.stop()
                    else:
                        pygame.mixer.music.play(-1, 0.0)
                    musicPlaying = not musicPlaying
   
    if started == True:
        foodCounter += 1
        if foodCounter >= NEWFOOD:
            # add new food
            foodCounter = 0
            foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - 20), random.randint(0, WINDOWHEIGHT - 20), 20, 20))

    # draw the black background onto the surface
    if not line:
        windowSurface.fill(BLACK)

    # move the player
    if moveDown and player.bottom < WINDOWHEIGHT:
        player.top += MOVESPEED
    if moveUp and player.top > 0:
        player.top -= MOVESPEED
    if moveLeft and player.left > 0:
        player.left -= MOVESPEED
    if moveRight and player.right < WINDOWWIDTH:
        player.right += MOVESPEED


    # check if the block has intersected with any food squares.
    if started == True:
        for food in foods[:]:
            if player.colliderect(food):
                foods.remove(food)
                score += 1
                if sizeCounter == nextSize - 1:
                    player = pygame.Rect(player.left, player.top, player.width + 2, player.height + 2)
                    playerStretchedImage = pygame.transform.scale(playerImage, (player.width, player.height))
                    sizeCounter = 0
                else:
                    sizeCounter += 1
                if musicPlaying:
                    pickUpSound.play()
        if timerTicker == Tick:
           timerTicker = 0
           timer -= 1
        elif timer == 0:
            started = False
            Finish = True
            moveLeft = False
            moveRight = False
            moveUp = False
            moveDown = False
            GameOverSound.play()
        else:
            timerTicker += 1

    # draw the food
    for food in foods:
        windowSurface.blit(foodImage, food)

    # draw the block onto the surface
    if showMenu == True:
        pygame.draw.rect(windowSurface, RED, (textRect.left - 40, textRect.top - 20, textRect.width + 80, textRect.height + 40))
        windowSurface.blit(text, textRect)
        windowSurface.blit(textEnter, textEnterRect)
    elif starting == True:
        textHuge = hugeFont.render(str(needed), True, WHITE, RED)
        windowSurface.blit(textHuge, textHugeRect)
        if needed == 0:
            started = True
            starting = False
            foods = []
            for i in range(20):
                foods.append(pygame.Rect(random.randint(0, WINDOWWIDTH - 20), random.randint(0, WINDOWHEIGHT - 20), 20, 20))
        else:
            if neededTicker == Tick:
                neededTicker = 0
                needed -= 1
            else:
                neededTicker += 1
    elif Finish == True:
        pygame.draw.rect(windowSurface, RED, (windowSurface.get_rect().left + 20, windowSurface.get_rect().top + 40, windowSurface.get_rect().width - 40, windowSurface.get_rect().height - 80))
        windowSurface.blit(textGameOver, textGameOverRect)
        windowSurface.blit(textEndScore, textEndScoreRect)
    else:
        windowSurface.blit(playerStretchedImage, player)
        textScore = smallFont.render('Score: ' + str(score), True, WHITE, RED)
        textTimer = smallFont.render('Timer: ' + str(timer), True, WHITE, RED)
        pygame.draw.rect(windowSurface, RED, (textScoreRect.left, textScoreRect.top, textScoreRect.width + 20, textScoreRect.height + 20))
        windowSurface.blit(textScore, textScoreRect)
        windowSurface.blit(textTimer, textTimerRect)

    # draw the window onto the screen
    pygame.display.update()
    mainClock.tick(Tick)
